--- old/usr/src/cmd/cron/at.c	2015-08-18 00:15:49.306055760 +0300
+++ new/usr/src/cmd/cron/at.c	2015-08-18 00:15:49.314098376 +0300
@@ -101,6 +101,7 @@
 static char *mkjobname(time_t);
 static time_t parse_time(char *);
 static time_t gtime(struct tm *);
+static void escapestr(char *);
 void atabort(char *)__NORETURN;
 void yyerror(void);
 extern int yyparse(void);
@@ -546,6 +547,23 @@
 }
 
 /*
+ * Escape a string to be used inside the job shell script.
+ */
+static void
+escapestr(char *str)
+{
+	char c;
+	putchar('\'');
+	while ((c = *str++) != '\0') {
+		if (c != '\'')
+			putchar(c);
+		else
+			printf("\'\\\'\'"); /* ' -> '\'' */
+	}
+	putchar('\'');
+}
+
+/*
  * make job file from proto + stdin
  */
 static void
@@ -678,7 +696,7 @@
 			if (seteuid(effeusr) < 0) {
 				atabort(CANTCHUID);
 			}
-			printf("%s", dirbuf);
+			escapestr(dirbuf);
 			break;
 		case 'm':
 			printf("%o", um);
